#ifndef EXP_H
#define EXP_H

typedef enum {
 EXP_XOR,
 EXP_AND,
 EXP_OR,
 EXP_EQ
 } ExpSymbolType;

typedef struct{
 ExpSymbolType type;
 char* string;
 int presedence;
 } ExpSymbol;


typedef struct ExpStruct{
 enum {TERM, NONTERM} type;
 
 struct ExpStruct* childA;
 struct ExpStruct* childB;
 struct ExpStruct* next_symbol;
 ExpSymbolType symbol;
 char* name;
 int index;
 int invert;
 }Exp;

int symbol_count;
Exp* symbols;


Exp* exp_exp(char* ptr, char** endptr, int presedence);
Exp* exp_val(char* ptr,char** endptr);
Exp* exp_get_symbol(char* start,char** end);
ExpSymbol* exp_find_symbol (char* ptr, char** endptr);
Exp* exp_operate(Exp* childA, Exp* childB, ExpSymbolType symbol);

#endif
