#include <stdlib.h>
#include "exp.h"

char evaluate(Exp* expression, char* values);
char evaluate2(Exp* expression, char* values);
char invert(char in);
int tablehash(char* values);
void setsubs(char* values);

char *table;

int perfect_equations = 0;
int gen_perfect = 1;
int gen_circuit = 1;
int spreadsheet = 0;
int spreadsheet2 = 0;
int spreadsheet3 = 0;
int spreadsheet4 = 0;
int progress = 1;

main (int argc, char** argv)
{
 char* string;
 char* left;
 char* values;
 int missing;
 int *posibilities, *results1, *results2, *results3;
 int total;
 int currenttotal = 0;
 int tablesize=1;
 
 Exp* expression;
 int argindex = 1;

 string = argv[argindex++];
 if (!string){printf("Error\n"); return;}

 while ('-' == *string || '+' == *string ) {
    int plus = ('+' == *string);
    while (*(++string)){
        switch (*string) {
            case 'h':
            case '?':
                printf ("Early output test\n");
                printf ("early [-/+ options] \"Equation\"\n");                
                printf (" -/+ h             Help\n");
                printf (" -/+ e             Print out perfect early equations [off]\n");
                printf (" -/+ p             Calculate perfect circuit [on]\n");
                printf (" -/+ c             Calculate given circuit [on]\n");
                printf (" -/+ 1             Print spreadsheet 1 data [off]\n");
                printf (" -/+ 2             Print spreadsheet 2 data [off]\n");
                printf (" -/+ v             Print progress %%\n [on]");
                
                return;
            case 'e':
                perfect_equations = plus;
                if (plus)
                    gen_perfect=1;
                break;
            case 'p':
                gen_perfect = plus;
                if (!plus)
                    perfect_equations=0;
                break;
            case 'c':
                gen_circuit = plus;
                break;
            case '1':
                spreadsheet = plus;
                break;
            case '2':
                spreadsheet2 = plus;
                break;
            case '3':
                spreadsheet3 = plus;
                break;
            case '4':
                spreadsheet4 = plus;
                break;
            case 'v':
                progress = plus;
                break;
            }
        }
    string = argv[argindex++];
    if (!string) {printf("Error\n"); return;}
    }

 symbol_count=0;
 symbols=NULL; expression = exp_exp(string, &left, 0);
 if (!left) {printf("Error\n"); return;}
 if (progress)  printf("Parsed %d characters\n", left- string);
 if (progress)  printf("Unparsed:%s\n", left);
 if (progress)  printf("%s;\n", string);
 if (progress)  while (left-- > string) printf(" ");
 if (progress)  printf("^\n");
 if (progress)  printf("Found %d inputs\n", symbol_count);
 {
  int current = 1;
  for (missing = 0; missing<symbol_count; missing++)
    current *= 2;
  total = 0;
  for (missing = 0; missing <= symbol_count; missing++){
    total += current;
    current = current * (symbol_count-missing) / 2 / (missing+1);
    }
 }

 {
  for (missing = 0; missing<symbol_count; missing++)
    tablesize *= 3;
  table = malloc (sizeof(char)* tablesize);
 }
 values = malloc (sizeof(char)* symbol_count);
 posibilities = malloc (sizeof(int)* (symbol_count+1));
 results1 = malloc (sizeof(int)* (symbol_count+1));
 results2 = malloc (sizeof(int)* (symbol_count+1));
 results3 = malloc (sizeof(int)* (symbol_count+1));
 
 {
  for (missing=0; missing<=symbol_count; missing++){
    int reset;
    posibilities[missing]=0;
    results1[missing]=0;
    results2[missing]=0;
    results3[missing]=0;
    for (reset=0; reset<symbol_count; reset++)
        if (reset<missing) values[reset] = 0;
        else values[reset] = 1;
    if (progress) printf("Missing:%d %02.2f%% \n", missing, ((float)currenttotal*100)/total);
    
    while (1){
        int rotate;
        int rotate2;
        while (1){
            int increment;
            char rep;
            posibilities[missing]++;
            if (gen_circuit){
                rep = evaluate (expression, values);
                if (rep) results1[missing]++;
                }
            
            
//            for (rotate=0; rotate<symbol_count; rotate++) printf("%d", values[rotate]);
//            printf(": %d", rep);
//            printf("\n");
            
            if (gen_perfect){
                rep = evaluate2 (expression, values);
                if (rep) results2[missing]++;
                }

            increment=0;
            while( increment<symbol_count && !(values[increment] & 1)){
                if (values[increment]) values[increment] = 1;
                increment++;
                }
            if (increment >= symbol_count) break;
            values[increment]=2;
            }
        rotate = 0;
        if (missing >= symbol_count) break;
        if (values[0]){
            while (values[++rotate]);
            if (rotate >= (symbol_count-missing)) break;
            rotate2 = 0;
            while (!values[rotate]){
                rotate2++;
                values[rotate++]=1;
                }
            values[rotate]=0;
            rotate2--;
            while (rotate2--) values[rotate2]=0;
            }
        else {
            while (!values[++rotate]);
            values[rotate]=0;
            values[rotate-1]=1;
            }
        for (reset=0; reset<symbol_count; reset++) //unnecesary?
            if (values[reset]) values[reset]=1;
        }
    currenttotal += posibilities[missing];
        
    
    
    }
 }
float last1=1;
float average1=0;
float last2=1;
float average2=0;

if (progress) {
 for (missing=0; missing<=symbol_count; missing++){
    printf("%d of %d present, of the %d combinations there are %d early outputs(%.2f\%) out of a possible %d (%.2f\%)\n",
        symbol_count-missing, symbol_count, posibilities[missing], results1[missing],
        ((float)results1[missing])/ ((float)posibilities[missing])*100,
                                        results2[missing],
        ((float)results2[missing])/ ((float)posibilities[missing])*100);
    average1 += (last1 - (((float)results1[missing])/ ((float)posibilities[missing]))) * (symbol_count-missing+1);
    last1 = (((float)results1[missing])/ ((float)posibilities[missing]));
    average2 += (last2 - (((float)results2[missing])/ ((float)posibilities[missing]))) * (symbol_count-missing+1);
    last2 = (((float)results2[missing])/ ((float)posibilities[missing]));
    }
 printf("Circuit average inputs needed:%.2f (%.2f%%)\n",average1, average1/symbol_count*100);
 printf("Perfect average inputs needed:%.2f (%.2f%%)\n",average2, average2/symbol_count*100);
 }



if (spreadsheet){
 for (missing=symbol_count; missing>=0; missing--){
    printf("%f, %f, ,",
        ((float)(symbol_count-missing)/(float)symbol_count),
        ((float)(symbol_count-missing)/(float)symbol_count));
    }
 printf("\n");
 for (missing=symbol_count; missing>=0; missing--){
    printf("%f, %f, ,",
        ((float)results1[missing])/ ((float)posibilities[missing]),
        ((float)results2[missing])/ ((float)posibilities[missing]));
    }
 printf("\n");
 }

if (spreadsheet2){
 for (missing=symbol_count; missing>=0; missing--){
    printf("%f, ",
        ((float)(symbol_count-missing)/(float)symbol_count));
    }
 printf("\n");
 for (missing=symbol_count; missing>=0; missing--){
    printf("%f, ",
        ((float)results1[missing])/ ((float)posibilities[missing]));
    }
 printf("\n");
 }

if (spreadsheet3){
 for (missing=symbol_count; missing>=0; missing--){
    printf("%f, ",
        ((float)(symbol_count-missing)/(float)symbol_count));
    }
 printf("\n");
 for (missing=symbol_count; missing>=0; missing--){
    printf("%f, ",
        ((float)results2[missing])/ ((float)posibilities[missing]));
    }
 printf("\n");
 }

if (spreadsheet4){
 for (missing=symbol_count; missing>=0; missing--){
    printf("%f, %f \n",
        ((float)(symbol_count-missing)/(float)symbol_count),
        ((float)results2[missing])/ ((float)posibilities[missing]));
    }
 printf("\n");
 }


if (perfect_equations) {
 int index;
 int temp;

 for (missing = 0; missing<symbol_count; missing++){
    Exp* search = symbols;
    while (search){
        if (search->index == missing) break;
        search = search->next_symbol;
        }
    if (strlen(search->name)>=5){
        search->name[5]=0;
        printf("%s",search->name);
        }
    else {
        printf("%s",search->name);
        for (index=strlen(search->name); index<5; index++)
            printf(" ");
        }
    }

 printf("=  Values\n");
 int mask;
 for (mask=0; mask <= 1; mask++)
  for (index=0; index<tablesize; index++){
    if (!(table[index] & 4) && (table[index] & (1<<mask))){
        temp=index;
        int care=0;
        for (missing = symbol_count-1; missing>=0; missing--){
            int current = temp%3;
            temp=temp/3;
            values[missing] = current;
            }
        for (missing = 0; missing<symbol_count; missing++){
            switch (values[missing]){
                case 0:
                    printf("x    ");
                    break;
                case 1:
                    printf("0    ");
                    care++;
                    break;
                case 2:
                    printf("1    ");
                    care++;
                    break;
                }
            }
        results3[care]++;
        printf("=>  %d", mask);
        if (!evaluate (expression, values))
            printf(" Uncaught");
        printf("\n");
        }
    }
 int count=0;
 int total=0;
 for (missing = 0; missing<symbol_count+1; missing++){
    printf("%d minterms with %d care inputs\n", results3[missing], missing);
    count += results3[missing];
    total += results3[missing] * missing;
    }
 printf ("Average of %f/%d care inputs per minterm\n", (float)total / count, symbol_count);
 }

}


char evaluate(Exp* expression, char* values)
{ 
 char ret=0;
 char tempa, tempb;
 
 if (expression->type == TERM) ret = values[expression->index];
 else {
    switch (expression->symbol){
        case EXP_AND:
            tempa = evaluate(expression->childA, values);
            if (tempa & 1) {ret = 1; break;}
            tempb = evaluate(expression->childB, values);
            if (tempb & 1) {ret = 1; break;}
            else if ((tempa == 2) && (tempb == 2)) ret = 2;
            break;
            
            break;
        case EXP_OR:
            tempa = evaluate(expression->childA, values);
            if (tempa & 2) {ret = 2; break;}
            tempb = evaluate(expression->childB, values);
            if (tempb & 2) {ret = 2; break;}
            else if ((tempa == 1) && (tempb == 1)) ret = 1;
            break;
            
        case EXP_XOR:
            tempa = evaluate(expression->childA, values);
            if (!tempa) break;
            tempb = evaluate(expression->childB, values);
            if (!tempb) break;
            if (tempb == tempa) ret = 1;
            else ret = 2;
            break;
        default:
            printf("what the fuck is this shit charlie?\n");
        }
    }


 if (expression->invert) return invert(ret);
 else return ret;
}

char evaluate2(Exp* expression, char* values)
{
 int index;
 char rep1;
 char rep2;
 for (index=0; index<symbol_count; index++){
    if (!values[index]){
        values[index]= 1;
        rep1 = table[tablehash(values)];
        values[index]= 2;
        rep2 = table[tablehash(values)];
        values[index]= 0;
        if (rep1 & rep2 & 3){
            table[tablehash(values)] = rep1&3;
            if (perfect_equations) setsubs(values);
            return rep1;
            }
        else {
            table[tablehash(values)] = 0;
            return 0;
            }
        }
    
    }
 rep1 = evaluate(expression, values);
 table[tablehash(values)] = rep1;
 return rep1;
}


int tablehash(char* values)
{
 int index = 0;
 int count;
 for (count=0; count <symbol_count; count ++){
    index=(index * 3) + (values[count] & 3);
    }
 return index;
}

void setsubs(char* values)
{
 int index;
 
 for (index=0; index<symbol_count; index++){
    if (!values[index]){
        values[index]= 1;
        table[tablehash(values)] |= 4;
        values[index]= 2;
        table[tablehash(values)] |= 4;
        values[index]= 0;        
        }
    }
 
 
 return;
}


char invert(char in)
{
 return ((in>>1)&1) | ((in&1)<<1);
}
